#include "hmg.ch"

*-----------------------------------------------------*
* (©) Mustafa López  mustalopez@gmail.com  01-11-2020 *
*-----------------------------------------------------*
 
*------------------------------------------------------------* 
 FUNCTION MAIN   
*------------------------------------------------------------* 
 REQUEST DBFCDX , DBFFPT , DBFDBT
 RDDSETDEFAULT( "DBFCDX" )

 SET NAVIGATION EXTENDED
 SET TOOLTIPSTYLE BALLOON 

 PRIVATE base0 ,base1,  base2 ,  base3 , nXy
 PRIVATE bmi1  , bmi2, bmi3 , xRepRCB  := ""
 PRIVATE bmi1x , bmi2x, bmi3x ,cValor ; xTipxC := ""
 PRIVATE DCC1,DCC2,DCC3,DCC4 , cValorD , cValorE ,cValorF 
 PRIVATE abc ,xfc1,  xfc2, xfc3 , xfc4 , xfQ1 ,xfQ2 ,xfQ3 
 PRIVATE unox2 , unox3 , acol  , aNome :={}  
 PRIVATE mirax , miry2 , finalQ ,graba1,graba2
 PRIVATE uVal01 , uVal02, uVal03 , apar_5 := 0 
 PRIVATE grc, gcg, gcb ,  Xgcr ,Xgcg , Xgcb , QRGB , graRGB 
 
 gcr := gcg := gcb := 0

*-------------------------------------------------------------------*
 CreateArray()   // <== Se Crea Array deBase de datos BColory.dbf
*-------------------------------------------------------------------*

  DEFINE WINDOW Form_1 AT 0,0 WIDTH 688 HEIGHT 455 TITLE "  Convert HEX to RGB Decimal  v.02"; 
                       ICON 'Logo' MAIN NOSIZE  NOMINIMIZE NOMAXIMIZE BACKCOLOR { 096,110,192} 

                 ON KEY ESCAPE ACTION Form_1.Release

   @ 025,130 LABEL LabeL_00s VALUE  "Convert Hex to RGB Decimal" WIDTH 300 HEIGHT 030 FONT "Arial" SIZE 12 BOLD  BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255}     
   @ 025,475 LABEL LabeL_01s VALUE  "Colors Name Database"       WIDTH 300 HEIGHT 030 FONT "Arial" SIZE 12 BOLD  BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255}     


    DEFINE IMAGE Fondo_0Q
         ROW 024 ; COL 096 ; WIDTH 23 ; HEIGHT 23   
         PICTURE 'Resource\RGB3.bmp'   
         STRETCH .T.
     END IMAGE

    DEFINE IMAGE Fondo_1Q
         ROW 128 ; COL 096 ; WIDTH 23 ; HEIGHT 23   
         PICTURE 'Resource\RGB3.bmp'   
         STRETCH .T.
    END IMAGE

    DEFINE IMAGE Fondo_2Q
         ROW 024 ; COL 445 ; WIDTH 23 ; HEIGHT 23   
         PICTURE 'Resource\RGB3.bmp'  
         STRETCH .T.
    END IMAGE

    @ 061,040 LABEL LabeL_1s VALUE  "Código HexaDecimal" WIDTH 176 HEIGHT 027 FONT "Arial" SIZE 11 BOLD BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255} 

    DEFINE TEXTBOX Tex_01  
        ROW    060
        COL    215  
        WIDTH  180  
        HEIGHT 023 
        VALUE  ""
        MAXLENGTH 7
        UPPERCASE .T.
        DISABLEDBACKCOLOR { 180,238,180 } 
        DISABLEDFONTCOLOR { 000,000,000 }
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR { 000,000,000 } 
        INPUTMASK "#"+"!!!!!!" 
    END TEXTBOX

    @ 096,040 LABEL LabeL_2s  VALUE "Código RGB Decimal"  WIDTH 176 HEIGHT 027 FONT "Arial" SIZE 11 BOLD   BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255}  

    DEFINE TEXTBOX Tex_02  
        ROW    095
        COL    215  
        WIDTH  180 
        HEIGHT 023 
        VALUE  ""   
        READONLY .T.
        DISABLEDBACKCOLOR  { 180,200,255 }    
        DISABLEDFONTCOLOR NIL
    END TEXTBOX

    @ 130,130 LABEL LabeL_02s VALUE "Convert RGB Decimal to HEX" WIDTH 300 HEIGHT 030 FONT "Arial" SIZE 12 BOLD  BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255} 

    @ 161,040 LABEL LabeL_3s  VALUE "Código RGB Decimal"  WIDTH 176 HEIGHT 027 FONT "Arial" SIZE 11 BOLD   BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255}            

    DEFINE TEXTBOX Tex_03  
        ROW    160
        COL    215  
        WIDTH  180 
        HEIGHT 023 
        VALUE  "{ 000,000,000 }"   
        MAXLENGTH 9  
        UPPERCASE .T.
        DISABLEDBACKCOLOR { 180,238,180 } 
        DISABLEDFONTCOLOR { 000,000,000 }
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR { 000,000,000 } 
        INPUTMASK "{ 999,999,999 }"
    END TEXTBOX

    @ 196,040 LABEL LabeL_4s VALUE  "Código HexaDecimal" WIDTH 176 HEIGHT 027 FONT "Arial" SIZE 11 BOLD BACKCOLOR { 096,110,192} FONTCOLOR { 151,223,255} 

    DEFINE TEXTBOX Tex_04 
        ROW    195
        COL    215 
        WIDTH  180 
        HEIGHT 023 
        VALUE  ""  
        READONLY .T.
        DISABLEDBACKCOLOR { 180,200,255 }    
        DISABLEDFONTCOLOR NIL      
    END TEXTBOX

*------------------------------------------------------------------------*

    @ 61,450 COMBOBOX combo_1    ;
          WIDTH 200 HEIGHT 023   ;        
          ITEMS anome            ;  
          value 1                ;
          ON CHANGE ArracaColor() 

    DEFINE TEXTBOX Text_001X 
        ROW    095
        COL    450 
        WIDTH  200  
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Search by Any Letter"
        ONCHANGE BuscaReg(cValor)   
        FONTBOLD .F.
        FONTITALIC .F.
        ONENTER BuscaReg(cValor)  
        VISIBLE .T.
        READONLY .F.
        BACKCOLOR { 221,160,221 }  
        FONTCOLOR { 000,000,000 }  
        VALUE ""
        UPPERCASE .T.   
    END TEXTBOX

    DEFINE TEXTBOX Control_13
        ROW    130  
        COL    450
        WIDTH  200
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Color_Name" 
        FONTBOLD .F.
        FONTITALIC .F.
        VISIBLE .T.
        VALUE ""            
        UPPERCASE .T. 
        LOWERCASE .F. 
        READONLY .T.
        DISABLEDBACKCOLOR { 180,200,255 }
    END TEXTBOX

*------------------------------ Box Color Tonality  -----------------------*

     @ 230,500 LABEL Label_3x             ;    
	        WIDTH 380 HEIGHT 18       ;
	        VALUE 'Color Tonality'    ;
                BACKCOLOR { 096,110,192}  ;
                FONTCOLOR { 151,223,255}  ;
	        FONT 'Arial' SIZE 11 BOLD 
      
       DEFINE LABEL Label_1x     
              ROW    260
              COL    450  
              WIDTH  200
              HEIGHT 070
              VALUE ""
              FONTNAME "Arial"
              FONTSIZE 9
              FONTBOLD .T.
              FONTITALIC .F.
              VISIBLE .T.
              ACTION CopyClipboard()
              BACKCOLOR NIL  
       END LABEL

*--------------------------------------------------------------------------* 

    DEFINE TEXTBOX Control_23
        ROW    160   
        COL    450  
        WIDTH  200
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code RGB"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR { 180,200,255 }
        VALUE ""
    END TEXTBOX

    DEFINE TEXTBOX Control_33
        ROW    195  
        COL    450 
        WIDTH  200
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code HEX"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR { 180,200,255 }
        VALUE ""
    END TEXTBOX

*-------------------------------------------------------------------*

     DEFINE IMAGE Fondo_3Q
         ROW 264 ; COL 040 ; WIDTH 60 ; HEIGHT 60    
         PICTURE 'Resource\RGB1.bmp'   
         STRETCH .T.
     END IMAGE

    DEFINE RADIOGROUP Radio_1
         ROW   330  
         COL   025                                   
         OPTIONS   { '  Convert RGB','  Convert HEX','  Select Colors' }   
         BACKCOLOR { 096,110,192}   
         VALUE 1 
         WIDTH 110
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP 'Convert RGB - Convert Hex' 
         HORIZONTAL .F.
         SPACING 020  
         ONCHANGE  Change_Search()
     END RADIOGROUP

*---------------------------------------------------------------------*

      DEFINE IMAGE Fondo_4Q
           ROW 256 ; COL 365 ; WIDTH 50 ; HEIGHT 70  
           PICTURE 'Resource\Clipboard.bmp'
           STRETCH .T.
       END IMAGE

     SetProperty("Form_1","Fondo_4Q","Enabled", .F. ) 
 
     @ 256,365 LABEL LabeL_5s VALUE "" WIDTH 050 HEIGHT 070  ACTION HexClipboard() TOOLTIP "Copy to Clipboard" TRANSPARENT  // Buttom Ficticio
 
     DEFINE  CHECKBOX Check_2
        ROW    341
        COL    345
        WIDTH  100
        HEIGHT 023 
        CAPTION SPACE(2) + 'Color RGB'   
        VALUE  .T. 
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .F.  
        TOOLTIP ""
        BACKCOLOR { 096,110,192}  
     END CHECKBOX

     DEFINE  CHECKBOX Check_3
        ROW    361 
        COL    345
        WIDTH  100  
        HEIGHT 023 
        CAPTION SPACE(2) + 'Color HEX'   
        VALUE  .T. 
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .F.     
        TOOLTIP ""
        BACKCOLOR { 096,110,192}  
     END CHECKBOX

*---------------------------------------------------------------------*

        DEFINE BUTTON Button_22
		ROW    237
		COL    155
		WIDTH  170
		HEIGHT 035
		CAPTION SPACE(08)-"&Convert To RGB"
		ACTION ( Recupera_RGB() , BuscaReg1(cValorE) )                                     
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Convert To RGB"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\RGB.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

         DEFINE BUTTON Button_33
		ROW     277
		COL     155
		WIDTH   170
		HEIGHT  035
		CAPTION SPACE(08)-"&Convert To HEX"  
		ACTION  (  Recupera_HEX() , BuscaReg2(cValorD) ) 
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Convert To HEX"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\RGB.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

         DEFINE BUTTON Button_44
		ROW     318
		COL     155
		WIDTH   170
		HEIGHT  035
		CAPTION SPACE(05)-"&Select More Colors"  
		ACTION  {|| FgetForecolor()}  
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Select More Colors"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Palette.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON
 
         DEFINE BUTTON Button_55  
                ROW    357  
		COL    155
		WIDTH  170
		HEIGHT 035
		CAPTION SPACE(09)-"&Cleaning"        
		ACTION Limpia_RGB()      
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Cleaning"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Cleaner.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON
       

	 DEFINE BUTTON Button_66  
		ROW    357 
		COL    465 
		WIDTH  170
		HEIGHT 035
		CAPTION SPACE(09)-"&Exit"
		ACTION Form_1.Release    
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Exit"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Exit1.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON


  END WINDOW

     Form_1.Tex_01.Setfocus

     Form_1.Tex_01.Enabled     := .T. 
     Form_1.Tex_02.Enabled     := .T. 
     Form_1.Tex_03.Enabled     := .F. 
     Form_1.Tex_04.Enabled     := .F. 
     Form_1.Button_22.Enabled  := .T. 
     Form_1.Button_33.Enabled  := .F. 
     Form_1.Button_44.Enabled  := .F. 

     Form_1.combo_1.Value := 1   

    SETWINDOWCURSOR ( Form_1.Fondo_4Q.Handle , "Resource\SmoothHand.cur")
    SETWINDOWCURSOR ( Form_1.Button_55.Handle ,"Resource\SmoothHand.cur")

    HMG_ChangeWindowStyle ( GetControlHandle("Label_1x","Form_1"), LVS_REPORT, NIL, .T. ) 


  CENTER WINDOW Form_1
  ACTIVATE WINDOW Form_1

RETURN NIL



*---------------------------------------------------------*
 FUNCTION  ArracaColor()
*---------------------------------------------------------*

  Form_1.Control_13.Value :=""

  CreateArray()       // <== Para que se actualice Database

  mirax := Form_1.Combo_1.Value  
  go mirax 

  mirax   := BColory->COLOR_RGB
  miry2   := STRTRAN( ALLTRIM( mirax) , " " , "," ) 
  finalQ  :=  "{ " + miry2 +" }"

  Form_1.Label_1x.BACKCOLOR := &finalQ 

  Form_1.Control_13.Value  := ALLTRIM( Form_1.combo_1.DisplayValue ,1,1)       
  Form_1.Control_23.Value  := finalQ  
  Form_1.Control_33.Value  := BColory->COLOR_HEX
  
Return Nil 


*---------------------------------------------------------*
 FUNCTION Change_Search()
*---------------------------------------------------------*

DO CASE 

CASE Form_1.Radio_1.Value == 0
     Form_1.Tex_01.Setfocus   
     Form_1.Tex_01.Enabled     := .T. 
     Form_1.Tex_02.Enabled     := .T. 
     Form_1.Tex_03.Enabled     := .F. 
     Form_1.Tex_04.Enabled     := .F. 
     Form_1.Button_22.Enabled  := .T. 
     Form_1.Button_33.Enabled  := .F. 
     Form_1.Button_44.Enabled  := .F. 

CASE Form_1.Radio_1.Value == 1
     Form_1.Tex_01.Setfocus
     Form_1.Tex_01.Enabled     := .T. 
     Form_1.Tex_02.Enabled     := .T. 
     Form_1.Tex_03.Enabled     := .F. 
     Form_1.Tex_04.Enabled     := .F. 
     Form_1.Button_22.Enabled  := .T. 
     Form_1.Button_33.Enabled  := .F. 
     Form_1.Button_44.Enabled  := .F. 

CASE Form_1.Radio_1.Value == 2
     Form_1.Tex_03.Setfocus
     Form_1.Tex_01.Enabled     := .F. 
     Form_1.Tex_02.Enabled     := .F. 
     Form_1.Tex_03.Enabled     := .T. 
     Form_1.Tex_04.Enabled     := .T. 
     Form_1.Button_22.Enabled  := .F. 
     Form_1.Button_33.Enabled  := .T. 
     Form_1.Button_44.Enabled  := .F. 

CASE Form_1.Radio_1.Value == 3
     Form_1.Tex_01.Enabled     := .F. 
     Form_1.Tex_02.Enabled     := .F. 
     Form_1.Tex_03.Enabled     := .F. 
     Form_1.Tex_04.Enabled     := .F. 
     Form_1.Button_22.Enabled  := .F. 
     Form_1.Button_33.Enabled  := .F. 
     Form_1.Button_44.Enabled  := .T. 

OTHERWISE

ENDCASE

RETURN


*------------------------------------------------------------------------------*
  FUNCTION Limpia_RGB()   
*------------------------------------------------------------------------------*

  Form_1.Combo_1.Value := 1

  Form_1.Tex_01.Value := "#" 
  Form_1.Tex_02.Value := "" 

  Form_1.Tex_03.Value := "{ 000,000,000 }"    
  Form_1.Tex_04.Value := ""
 
*--------------------------------------------------------*

  Form_1.Label_1x.BACKCOLOR := { 255,255,255 }

  Form_1.Text_001X.vALUE  :="" 
  Form_1.Control_13.Value :=""
  Form_1.Control_23.Value :=""
  Form_1.Control_33.Value :=""

  Form_1.Tex_01.Setfocus
 
  Return Nil


*--------------------------------------*
  Function FgetForecolor()
*--------------------------------------*

   gcr := gcg := gcb := 0   // < == Muy Importante no Borrar !!!

   PRIVATE  facol := getcolor({gcr, gcg, gcb})

   gcr := facol[1]
   gcg := facol[2]
   gcb := facol[3]

   Change_ColorsPlusF()

 Return Nil

*--------------------------------------*
 Function Change_ColorsPlusF()
*--------------------------------------*

 DCC1:=NTOC( gcr, 16, 2, '0' ) 
 DCC2:=NTOC( gcg, 16, 2, '0' )
 DCC3:=NTOC( gcb, 16, 2, '0' )
 DCC4:="#"+ DCC1 + DCC2 + DCC3

  IF DCC4 ==  ALLTRIM("#******")   // <== Error de cancel Getcolor
     Return(.F.)
  ELSE
     BuscaReg3(cValorF)   
  ENDIF


Return Nil


*------------------------------------------------------------------------------*
  FUNCTION Recupera_RGB()     
*------------------------------------------------------------------------------*

  xTipxC  := ALLTRIM( Form_1.Tex_01.Value )

  base0 := xTipxC  //   "#F2FC00"
  base1 := SUBSTR ( base0,2,2)
  base2 := SUBSTR ( base0,4,2)
  base3 := SUBSTR ( base0,6,7)

  bmi1 := CTON(  base1,16,2,"0" )
  bmi2 := CTON(  base2,16,2,"0" )
  bmi3 := CTON(  base3,16,2,"0" )

  IF bmi1  = 0 
     bmi1x := ALLTRIM("000" )
  ELSE 
     bmi1x := ALLTRIM( STR(bmi1) )
  ENDIF

  IF bmi2  = 0 
     bmi2x := ALLTRIM("000" )
  ELSE 
     bmi2x := ALLTRIM( STR(bmi2) )
  ENDIF

  IF bmi3  = 0 
     bmi3x := ALLTRIM("000" )
  ELSE 
     bmi3x := ALLTRIM( STR(bmi3) )
  ENDIF

  xRepRCB := " { "+ bmi1x +" , "+ bmi2x +" , " + bmi3x +" } "
 
  Form_1.Tex_02.Value  :=   xRepRCB

  Form_1.Label_1x.BACKCOLOR := &(xRepRCB)


Return Nil 


*-------------------------------------------------------------------------------*
 FUNCTION  Recupera_HEX()  
*-------------------------------------------------------------------------------*
   
   abc := ALLTRIM( Form_1.Tex_03.Value)   

   xfc1 := SUBSTR( abc , 2, 4) 
   xfc2 := SUBSTR( abc , 7, 3) 
   xfc3 := SUBSTR( abc , 11, 3) 
  
   DCC1:=NTOC( VAL(xfc1) , 16, 2, '0' ) 
   DCC2:=NTOC( VAL(xfc2) , 16, 2, '0' )
   DCC3:=NTOC( VAL(xfc3) , 16, 2, '0' )
   DCC4:="#"+ DCC1 + DCC2 + DCC3

   Form_1.Tex_04.Value        := ALLTRIM( DCC4 )  
   Form_1.Label_1x.BACKCOLOR  := &(abc)

 Return Nil 


*-------------------------------------------------------------------------------*
 FUNCTION HexClipboard()  
*-------------------------------------------------------------------------------*
  
      unox2 := Form_1.Check_2.Value 
      unox3 := Form_1.Check_3.Value 


 IF  Form_1.Radio_1.Value == 1
     IF unox2 == .T. .AND. unox3 == .T. 
        System.Clipboard  := xRepRCB  + CRLF + CRLF + SPACE(1) + xTipxC
        MsgInfo ( "Value RGB :" + SPACE(3) + xRepRCB  + CRLF + CRLF +;
                  "Value HEX :" + SPACE(3) + xTipxC  ,"Copy to Clipboard")
     ENDIF
     IF unox2 == .F. .AND. unox3 == .T. 
        System.Clipboard :=  xTipxC
        MsgInfo ( "Value HEX :" + SPACE(3) +   xTipxC  ,"Copy to Clipboard")
     ENDIF
     IF unox2 == .T. .AND. unox3 == .F. 
        System.Clipboard  := xRepRCB 
        MsgInfo ( "Value RGB :" + SPACE(3) + xRepRCB , "Copy to Clipboard")
     ENDIF

 ENDIF

 IF  Form_1.Radio_1.Value == 2
     IF unox2 == .T. .AND. unox3 == .T. 
        System.Clipboard  := abc + CRLF + CRLF + SPACE(1) + ALLTRIM( DCC4)
        MsgInfo ( "Value RGB :" + SPACE(3) + abc + CRLF + CRLF +;          
                  "Value HEX :" + SPACE(3) + ALLTRIM( DCC4 ) ,"Copy to Clipboard")    
     ENDIF
     IF unox2 == .T. .AND. unox3 == .F.   
        System.Clipboard  := abc 
        MsgInfo ( "Value RGB :" + SPACE(3) + abc ,"Copy to Clipboard")
     ENDIF
     IF unox2 == .F. .AND. unox3 == .T.    
        System.Clipboard  :=  ALLTRIM( DCC4 )

        MsgInfo ( "Value HEX :" + SPACE(3) + ALLTRIM( DCC4 ) , "Copy to Clipboard")
    ENDIF

ENDIF

Return Nil

*---------------------------------------------------------*
 FUNCTION CopyClipboard()
*---------------------------------------------------------*
  
  uVal01 := Form_1.Control_13.Value   
  uVal02 := Form_1.Control_23.Value   
  uVal03 := Form_1.Control_33.Value  

  System.Clipboard  :=   uVal01  + CRLF + uVal02  + CRLF + uVal03

         MsgInfo ( "Color Name: " + SPACE(3) + ALLTRIM( uVal01) + CRLF + CRLF + ;
                   "Value RGB : " + SPACE(3) + ALLTRIM( uVal02) + CRLF + CRLF + ;                 
                   "Value HEX : " + SPACE(3) + ALLTRIM( uVal03) ,"Copy to Clipboard")


Return Nil

*-----------------------------------------------------------*
 FUNCTION BuscaReg(cValor)  
*-----------------------------------------------------------*
 
  cValor := Form_1.Text_001X.Value 

  Form_1.combo_1.Value := 1 

  dbcloseall()

  SELECT 1  
  USE BColory 
  INDEX ON COLOR_NAME TO BName 
 
  dbcloseall()
  SELECT 1  
  Use BColory INDEX BName

	IF !empty(cValor)
           DbSeek(cValor)
		IF FOUND()
		    Form_1.Control_13.Value := BColory->COLOR_NAME 
                    Form_1.Control_23.Value := BColory->COLOR_RGB
                    Form_1.Control_33.Value := BColory->COLOR_HEX  

                    mirax  := Form_1.Control_23.Value    
                    miry2  := STRTRAN( ALLTRIM( mirax) , " " , "," ) 
                    finalQ :=  "{ " + miry2 +" }"

                    Form_1.Control_23.Value := finalQ
                    Form_1.Label_1x.BACKCOLOR := &finalQ 
                   
		ENDIF	
	ENDIF
 RETURN NIL  


*-----------------------------------------------------------*
 FUNCTION BuscaReg1(cValorE)  
*-----------------------------------------------------------*

   xTipxC  := ALLTRIM( Form_1.Tex_01.Value )

   xRepRCB := " { "+ bmi1x +" , "+ bmi2x +" , " + bmi3x +" } "

   graba1 :=  ALLTRIM( bmi1x) + SPACE(1) + ALLTRIM( bmi2x)  + SPACE(1) + ALLTRIM(bmi3x ) 

   dbcloseall()
   SELECT 1  
   Use BColory INDEX BHEX 

       	IF !empty( xTipxC )
           DbSeek( xTipxC )

 	    IF FOUND()
		    Form_1.Control_13.Value   := BColory->COLOR_NAME 
                    Form_1.Control_23.Value   := xRepRCB 
                    Form_1.Control_33.Value   := xTipxC    
                    Form_1.Label_1x.BACKCOLOR := &xRepRCB                   
            ELSE
                    IF !FILE("numerator.mem") 
                        apar_5 := apar_5 + 1    
                    ELSE
                       RESTORE FROM numerator.mem ADDITIVE
                       apar_5 := apar_5 + 1 
                    ENDIF
  
             IF MsgYesNo( space(10)+"No Match Found --" + CHR(187) +SPACE(2) +  "NAMELESS" + ALLTRIM(STR(apar_5 )) + CRLF + CRLF + ;
                     "Do you want to add this Record to the Database ? ","Attention") 
 
                    Form_1.Control_13.Value   := "NAMELESS" + ALLTRIM(STR(apar_5 ))  
                    Form_1.Control_23.Value   :=  xRepRCB 
                    Form_1.Control_33.Value   :=   xTipxC    
                    Form_1.Label_1x.BACKCOLOR := &xRepRCB 

                    dbcloseall()
                    SELECT 1  
                    use BColory
                    dbGoBottom()
                    dbAppend()
                    REPLACE COLOR_NAME WITH  "NAMELESS" + ALLTRIM(STR(apar_5 ))
                    REPLACE COLOR_RGB  WITH  graba1
                    REPLACE COLOR_HEX  WITH  xTipxC   
                    REINDEX
                    dbcloseall()
                    SAVE TO numerator.mem ALL LIKE apar_*

                    CreateArray()

                        DoMethod( "Form_1","combo_1","DeleteAllItems") 
 
                    FOR nXy = 1 TO LEN(aNome)
                        DoMethod( "Form_1","combo_1","AddItem",aNome[nXy]) 
                    NEXT nXy
              
             ENDIF	
           ENDIF	
   ENDIF


 RETURN NIL  


*-----------------------------------------------------------*
 FUNCTION BuscaReg2(cValorD)   
*-----------------------------------------------------------*

  xfc4   :=  "{ "+ xfc1+","+ xfc2+","+ xfc3 + " }"
  graba2 :=  ALLTRIM( xfc1) + SPACE(1) + ALLTRIM( xfc2)  + SPACE(1) + ALLTRIM(xfc3 ) 
  DCC4   :="#"+ DCC1 + DCC2 + DCC3

  
  dbcloseall()
  SELECT 1  
  Use BColory INDEX BHex 

	IF !empty( DCC4 )
           DbSeek( DCC4 )
		IF FOUND()
		    Form_1.Control_13.Value   := BColory->COLOR_NAME 
                    Form_1.Control_23.Value   := xfc4  
                    Form_1.Control_33.Value   := DCC4       
                    Form_1.Label_1x.BACKCOLOR := &xfc4 
                  ELSE
                    IF !FILE("numerator.mem") 
                        apar_5 := apar_5 + 1    
                    ELSE
                       RESTORE FROM numerator.mem ADDITIVE
                       apar_5 := apar_5 + 1 
                    ENDIF

  
         IF MsgYesNo( space(10)+"No Match Found --" + CHR(187) +SPACE(2) +  "NAMELESS" + ALLTRIM(STR(apar_5 )) + CRLF + CRLF + ;
                     "Do you want to add this Record to the Database ? ","Attention") 

                    Form_1.Control_13.Value   := "NAMELESS" + ALLTRIM(STR(apar_5 ))      
                    Form_1.Control_23.Value   := xfc4 
                    Form_1.Control_33.Value   := DCC4    
                    Form_1.Label_1x.BACKCOLOR := &xfc4 

                    dbcloseall()
                    SELECT 1  
                    use BColory
                    dbGoBottom()
                    dbAppend()
                    REPLACE COLOR_NAME WITH  "NAMELESS" + ALLTRIM(STR(apar_5 ))
                    REPLACE COLOR_RGB  WITH  graba2
                    REPLACE COLOR_HEX  WITH  DCC4
                    REINDEX
                    dbcloseall()
                    SAVE TO numerator.mem ALL LIKE apar_*
     
                    CreateArray()

                        DoMethod( "Form_1","combo_1","DeleteAllItems") 
 
                    FOR nXy = 1 TO LEN(aNome)
                        DoMethod( "Form_1","combo_1","AddItem",aNome[nXy]) 
                    NEXT nXy
 
           ENDIF	
       ENDIF	
   ENDIF


 RETURN NIL  


*-----------------------------------------------------------*
 FUNCTION BuscaReg3(cValorF)   
*-----------------------------------------------------------*

  Xgcr := ALLTRIM(STR( gcr ))
  Xgcg := ALLTRIM(STR( gcg ))
  Xgcb := ALLTRIM(STR( gcb ))

  QRGB    := " { "+ Xgcr +" , "+ Xgcg +" , "+ Xgcb +" , "+" } "
  graRGB  :=  Xgcr + SPACE(1) + Xgcg + SPACE(1) + Xgcb
  DCC4   :="#"+ DCC1 + DCC2 + DCC3
  
  dbcloseall()
  SELECT 1  
  Use BColory INDEX BHex 

	IF !empty( DCC4 )
           DbSeek( DCC4 )
		IF FOUND()
		    Form_1.Control_13.Value   := BColory->COLOR_NAME 
                    Form_1.Control_23.Value   := QRGB   
                    Form_1.Control_33.Value   := DCC4       
                    Form_1.Label_1x.BACKCOLOR := &QRGB    
                  ELSE
                    IF !FILE("numerator.mem") 
                        apar_5 := apar_5 + 1    
                    ELSE
                       RESTORE FROM numerator.mem ADDITIVE
                       apar_5 := apar_5 + 1 
                    ENDIF

  
         IF MsgYesNo( Space(10)+"No Match Found --" + CHR(187) +SPACE(2) +  "NAMELESS" + ALLTRIM(STR(apar_5 )) + CRLF + CRLF + ;
                     "Do you want to add this Record to the Database ? ","Attention") 

                    Form_1.Control_13.Value   := "NAMELESS" + ALLTRIM(STR(apar_5 ))      
                    Form_1.Control_23.Value   :=  QRGB    
                    Form_1.Control_33.Value   :=  DCC4    
                    Form_1.Label_1x.BACKCOLOR :=  &QRGB    

                    dbcloseall()
                    SELECT 1  
                    use BColory
                    dbGoBottom()
                    dbAppend()
                    REPLACE COLOR_NAME WITH  "NAMELESS" + ALLTRIM(STR(apar_5 ))
                    REPLACE COLOR_RGB  WITH  graRGB   
                    REPLACE COLOR_HEX  WITH  DCC4
                    REINDEX
                    dbcloseall()
                    SAVE TO numerator.mem ALL LIKE apar_*
     
                    CreateArray()

                        DoMethod( "Form_1","combo_1","DeleteAllItems") 
 
                    FOR nXQ = 1 TO LEN(aNome)
                        DoMethod( "Form_1","combo_1","AddItem",aNome[nXQ]) 
                    NEXT nXQ
 
           ENDIF	
       ENDIF	
   ENDIF


 RETURN NIL  

*-----------------------------------------------------------*
 FUNCTION CreateArray()
*-----------------------------------------------------------*

  SELECT 1  
  USE BColory 
  INDEX ON COLOR_HEX  TO BHex 
  INDEX ON COLOR_NAME TO BName 
 

  dbcloseall()
  SELECT 1  
  USE BColory   //INDEX BName  <== Opcional ?
  
  aNome := {}

  do while !eof()
      aadd( aNome , BColory->COLOR_NAME )
      skip
  enddo	
 

Return Nil

*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*-_-*










